	include "pck1.inc"
; okaegi v 2
;	bally testrom 
;
;	all 19 solenoids are activated...
;
; dip switches 32, 31 ball set (1,1 -> 2, 1,0 -> 4, 0,1-> 5, 0,0 -> 3)
; dip switches used dip 28, match on
; dip switches used dip 27 , display credits
; dip switches used dip 26 , max credits
; dip switches used dip 25 , max credits (freegame)
;
; Memory chip map
;
; adr 1800 - 1fff U6	-> pck
; adr 5800-  58ff U6	-> pck 
; adr 1000 - 17ff U2	-> game rom
; adr 5000 - 57ff U2	-> game rom
;
;	
; 200 - 20f 				* Lamp board *
; 20f - 21e 				* aux lamp board *
; 21e - 240				* displays *
; 241 242 243 244 245 246 247 <- reserved for additional display (used only on vector / medusa)
;
; 264 - 28E			**** free (game or player specfic) ****
;
; 280 - 2ff 			save over power off
;
; game parameters			**** free ***
;     	2af 2b0				test 06
;	2b1 2b2				test 07
;	2b3 2b4				test 08
;	2b5 2b6				test 09
; 	2b7 2b8				test 10
;	2b9 2ba				test 11
;	2bb 2bc				test 12
;	2bd 2be				test 13
;	2bf				** free ***
;	2c0-2cf				** free player 1 save area ***
;	2d0-2df				** free player 2 save area ***
;	2e0-2df				** free player 3 save area ***
;	2f0-2ff				** free player 4 save area ***
;
; predefines lamps		
;
; $020A 8765FFFF
;  8 -> credit indicator	j3 13		
;  7 -> S.P. SHOOT AGAIN	j3 22		
;  6 -> MATCH			j2 8  / j1 4	
;  5 -> SHOOT AGAIN		j1 26 / j2 21	
;
; $020C 8765FFFF
;  8 -> Tilt			j2 10		
;  7 -> Game over		j2 11		
;  6 -> High score to date	j2 23		
;  5 -> Ball in play 		j2 22		
;
	org	$0047
;!!! 8 bit Variable here...(from $47 until $5A)
;
; variable XUSC1 could be used (will be counted down to zero...)
; variable XBON could be used for bonus
;!!!
	org	$026C
;!!! 4 bit variables here...(from $26C to $28E) 
; 4 bit means the lower for bits of a variable are always one
; a store of 00 in a variable declared here and a read of this variable results in 0f
;!!!
	org	$02AF
;!!! 4 bit Variable here...(until $2FF) 
; parameters who can be set during selfttest can be declared here
;
;!!!
	org	$1000
c1	db	$00		; checksum byte, leave it
	org	$1001
;
	mainen1	spin,sgame,egame,addpl,splayer,stplayer,balls,fcount
;
; parameter 4 and 5 is the version number 
; parameter 6 is the lamp number of the solenoid expander if you use more then 15 coils
;
	mainen2	zcross1,zcross2,zcross3,2,0,00
;	
	mainen3	afterdi,bscor,addpends,addscor,aftersco,knock,digitup,makeso,killso
;
; all solenoids must be defined once with a soldef
; type = 100	norm	(rest)	
; type = 101	perm	(coin lockout=1,flipperenable=4)
; type = (swnr)	Quick	(bumper)
;
; you find out the solenoid number if you study the solenoid schema of the pinball
; 	
; K1 relais
	soldef	4,101	
;
	soldef  3,101
	soldef  2,101
; coin lockout
	soldef  1,101
; scr	Q2
	soldef  0,100
; scr	Q1
	soldef  1,100
; scr	Q5
	soldef  2,100
; scr	q6
	soldef  3,100
; scr	q7 
	soldef	4,100
; scr	q3
	soldef  5,100
; scr	q4
	soldef  6,100
; scr	q8
	soldef  7,100
; scr	q13		
	soldef  8,100
; scr	q14		
 	soldef  9,100
; scr	q9
	soldef  10,100
; scr	q10
	soldef  11,100
; scr	q12
	soldef  12,100
; scr	q11
	soldef  13,40
; scr	q16
	soldef  14,100
;
; all 40 (or 48) switches must be defined once
;
	; credit button
	swdef	06,swcredit
	; coin 2
	swdef	09,swcoin
	; coin 3
	swdef	10,swcoin
	; coin 1
	swdef	11,swcoin

swcredit:	; add one player
	ldaa    #$04
	rts
swcoin:		; always two credits with one coin
	ldab 	#$02
	ldaa    #$07
	rts
;
; routines are activated in the following sequence
; power on 			-> spin
;				-> egame
; credit button pressed once	-> sgame
;				-> addpl  	a = 1
;				-> splayer 	a = 1
;				-> balls	a = 1, b = 00
; credit button pressed twice	-> addpl	a = 2
; ball hits score100		-> fcount	a = 0
; ball hits score100
; ball drains 		 
;				-> stplayer	a = 1
;				-> splayer	a = 2
;				-> balls	a = 2, b = 00
spin:		; coding for the pinball start (after power on)
	clra
	rts
sgame:		; coding for the game start	(after credit button is pressed once, or power on)
	clra
	rts
egame:		; coding for the game end	(or power on)
		; reset bonus , prepare for attract modus
	clra
	rts
addpl:		; coding for adding one player (repeated for every player, reg a holds player number)
		; a = 1 -> 1 player
		; a = 2 -> 2 player
		; a = 3 -> 3 player
		; a = 4 -> 4 player
	clra
	rts
splayer:	; coding when a ball is served to the player reg a holds player, only once per player, x holds player 
		; save area max 16 bytes (2c0 - 2ff)
	clra
	rts	
stplayer:	; coding when a ball drains  reg a holds player number , 
		; do here bonus count  x holds player
		; save area max f bytes (2c0 - 2ff)
	clra
	rts
balls:		; coding when a ball is served to a player, reg a holds player number, reg b holds reason
		; b = X0 -> normal ball
		; b = X1 -> we play an extra ball
		; b = X2 -> new ball (due to multiball lock)
		; scored with this ball ( x = 0 -> no, x= 8 -> yes)
		; do here: activate outhole solenoid, reset lamps for the next ball
	clra
	rts
fcount:		; first score for this ball, reg a holds player number
	clra
	rts
zcross1:
		; update your timers here beginn of zerocross (120 times per second)
	clra
	rts
zcross2:	; additional aux lamp board is updated if a not equ 0
	clra
	rts
zcross3:	; after fast react solenoid routine
	clra
	rts
afterdi:	; display interrupt (called for one character) could be used for addressing 6th display
		; a contains the display digit 
	clra
	rts
bscor:		; before add a score reg a holds player number
	clra
	rts
addscor:	; add the score reg a holds play number
	clra
	rts
addpends:	; before adding a pending score (one digit one number a call, reg a holds player number)
	clra
	rts
aftersco:	; after add a score (reg a holds play number) 
		; do here periodic things during game or attract modus
	clra
	rts
knock:		; freegame activate the knocker
	clra
	rts
digitup:	; start update a digit during scoring
		; digitup   start update digit during scoring (Reg a Loaded a= 0 + 10, a = 1 + 100, a = 2 + 1000...)
		; perfect place to activate chimes...
	clra
	rts
makeso:		; make sound reg a  > 0 application frame wants sound
		; a = 1 tilt
		; a = 2 search match
		; a = 3 game over
		; a = 4 testswitch 1
		; a = 5 testswitch 2
		; a = 6 game start
		; a = 7 add player
		; a = 8 pinball start
	clra
	rts
killso:		; stop running sound
	clra
	rts
attract:	; only activated during attract modus
; you can use XATT1,XATT2,XATT3,XATT4 (8 bit variables) here for the attract modus
	clra
	rts
;!!! end coding
	org	$17FF
 	db	$00
;;	parameter 2 is 6 or 7 digit displays
; 	parameter 3 is the additional adress if you have more than 40 switches
	mainen4	attract,7,00,35
;
	org	u2rest
;!!! continue coding here
;
;!!!
	org	$57FF
c6	db	$00
